// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package bucket

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// GetBucketRewindOKCode is the HTTP code returned for type GetBucketRewindOK
const GetBucketRewindOKCode int = 200

/*
GetBucketRewindOK A successful response.

swagger:response getBucketRewindOK
*/
type GetBucketRewindOK struct {

	/*
	  In: Body
	*/
	Payload *models.RewindResponse `json:"body,omitempty"`
}

// NewGetBucketRewindOK creates GetBucketRewindOK with default headers values
func NewGetBucketRewindOK() *GetBucketRewindOK {

	return &GetBucketRewindOK{}
}

// WithPayload adds the payload to the get bucket rewind o k response
func (o *GetBucketRewindOK) WithPayload(payload *models.RewindResponse) *GetBucketRewindOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get bucket rewind o k response
func (o *GetBucketRewindOK) SetPayload(payload *models.RewindResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetBucketRewindOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetBucketRewindDefault Generic error response.

swagger:response getBucketRewindDefault
*/
type GetBucketRewindDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.APIError `json:"body,omitempty"`
}

// NewGetBucketRewindDefault creates GetBucketRewindDefault with default headers values
func NewGetBucketRewindDefault(code int) *GetBucketRewindDefault {
	if code <= 0 {
		code = 500
	}

	return &GetBucketRewindDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get bucket rewind default response
func (o *GetBucketRewindDefault) WithStatusCode(code int) *GetBucketRewindDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get bucket rewind default response
func (o *GetBucketRewindDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get bucket rewind default response
func (o *GetBucketRewindDefault) WithPayload(payload *models.APIError) *GetBucketRewindDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get bucket rewind default response
func (o *GetBucketRewindDefault) SetPayload(payload *models.APIError) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetBucketRewindDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
