// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package configuration

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// ResetConfigOKCode is the HTTP code returned for type ResetConfigOK
const ResetConfigOKCode int = 200

/*
ResetConfigOK A successful response.

swagger:response resetConfigOK
*/
type ResetConfigOK struct {

	/*
	  In: Body
	*/
	Payload *models.SetConfigResponse `json:"body,omitempty"`
}

// NewResetConfigOK creates ResetConfigOK with default headers values
func NewResetConfigOK() *ResetConfigOK {

	return &ResetConfigOK{}
}

// WithPayload adds the payload to the reset config o k response
func (o *ResetConfigOK) WithPayload(payload *models.SetConfigResponse) *ResetConfigOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the reset config o k response
func (o *ResetConfigOK) SetPayload(payload *models.SetConfigResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ResetConfigOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
ResetConfigDefault Generic error response.

swagger:response resetConfigDefault
*/
type ResetConfigDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.APIError `json:"body,omitempty"`
}

// NewResetConfigDefault creates ResetConfigDefault with default headers values
func NewResetConfigDefault(code int) *ResetConfigDefault {
	if code <= 0 {
		code = 500
	}

	return &ResetConfigDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the reset config default response
func (o *ResetConfigDefault) WithStatusCode(code int) *ResetConfigDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the reset config default response
func (o *ResetConfigDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the reset config default response
func (o *ResetConfigDefault) WithPayload(payload *models.APIError) *ResetConfigDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the reset config default response
func (o *ResetConfigDefault) SetPayload(payload *models.APIError) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ResetConfigDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
