// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package idp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// GetLDAPEntitiesOKCode is the HTTP code returned for type GetLDAPEntitiesOK
const GetLDAPEntitiesOKCode int = 200

/*
GetLDAPEntitiesOK A successful response.

swagger:response getLDAPEntitiesOK
*/
type GetLDAPEntitiesOK struct {

	/*
	  In: Body
	*/
	Payload *models.LdapEntities `json:"body,omitempty"`
}

// NewGetLDAPEntitiesOK creates GetLDAPEntitiesOK with default headers values
func NewGetLDAPEntitiesOK() *GetLDAPEntitiesOK {

	return &GetLDAPEntitiesOK{}
}

// WithPayload adds the payload to the get l d a p entities o k response
func (o *GetLDAPEntitiesOK) WithPayload(payload *models.LdapEntities) *GetLDAPEntitiesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get l d a p entities o k response
func (o *GetLDAPEntitiesOK) SetPayload(payload *models.LdapEntities) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetLDAPEntitiesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetLDAPEntitiesDefault Generic error response.

swagger:response getLDAPEntitiesDefault
*/
type GetLDAPEntitiesDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.APIError `json:"body,omitempty"`
}

// NewGetLDAPEntitiesDefault creates GetLDAPEntitiesDefault with default headers values
func NewGetLDAPEntitiesDefault(code int) *GetLDAPEntitiesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetLDAPEntitiesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get l d a p entities default response
func (o *GetLDAPEntitiesDefault) WithStatusCode(code int) *GetLDAPEntitiesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get l d a p entities default response
func (o *GetLDAPEntitiesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get l d a p entities default response
func (o *GetLDAPEntitiesDefault) WithPayload(payload *models.APIError) *GetLDAPEntitiesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get l d a p entities default response
func (o *GetLDAPEntitiesDefault) SetPayload(payload *models.APIError) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetLDAPEntitiesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
