// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package idp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// UpdateConfigurationOKCode is the HTTP code returned for type UpdateConfigurationOK
const UpdateConfigurationOKCode int = 200

/*
UpdateConfigurationOK A successful response.

swagger:response updateConfigurationOK
*/
type UpdateConfigurationOK struct {

	/*
	  In: Body
	*/
	Payload *models.SetIDPResponse `json:"body,omitempty"`
}

// NewUpdateConfigurationOK creates UpdateConfigurationOK with default headers values
func NewUpdateConfigurationOK() *UpdateConfigurationOK {

	return &UpdateConfigurationOK{}
}

// WithPayload adds the payload to the update configuration o k response
func (o *UpdateConfigurationOK) WithPayload(payload *models.SetIDPResponse) *UpdateConfigurationOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update configuration o k response
func (o *UpdateConfigurationOK) SetPayload(payload *models.SetIDPResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateConfigurationOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
UpdateConfigurationDefault Generic error response.

swagger:response updateConfigurationDefault
*/
type UpdateConfigurationDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.APIError `json:"body,omitempty"`
}

// NewUpdateConfigurationDefault creates UpdateConfigurationDefault with default headers values
func NewUpdateConfigurationDefault(code int) *UpdateConfigurationDefault {
	if code <= 0 {
		code = 500
	}

	return &UpdateConfigurationDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the update configuration default response
func (o *UpdateConfigurationDefault) WithStatusCode(code int) *UpdateConfigurationDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the update configuration default response
func (o *UpdateConfigurationDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the update configuration default response
func (o *UpdateConfigurationDefault) WithPayload(payload *models.APIError) *UpdateConfigurationDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update configuration default response
func (o *UpdateConfigurationDefault) SetPayload(payload *models.APIError) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateConfigurationDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
