// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// GetSAUserPolicyOKCode is the HTTP code returned for type GetSAUserPolicyOK
const GetSAUserPolicyOKCode int = 200

/*
GetSAUserPolicyOK A successful response.

swagger:response getSAUserPolicyOK
*/
type GetSAUserPolicyOK struct {

	/*
	  In: Body
	*/
	Payload *models.AUserPolicyResponse `json:"body,omitempty"`
}

// NewGetSAUserPolicyOK creates GetSAUserPolicyOK with default headers values
func NewGetSAUserPolicyOK() *GetSAUserPolicyOK {

	return &GetSAUserPolicyOK{}
}

// WithPayload adds the payload to the get s a user policy o k response
func (o *GetSAUserPolicyOK) WithPayload(payload *models.AUserPolicyResponse) *GetSAUserPolicyOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get s a user policy o k response
func (o *GetSAUserPolicyOK) SetPayload(payload *models.AUserPolicyResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSAUserPolicyOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetSAUserPolicyDefault Generic error response.

swagger:response getSAUserPolicyDefault
*/
type GetSAUserPolicyDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.APIError `json:"body,omitempty"`
}

// NewGetSAUserPolicyDefault creates GetSAUserPolicyDefault with default headers values
func NewGetSAUserPolicyDefault(code int) *GetSAUserPolicyDefault {
	if code <= 0 {
		code = 500
	}

	return &GetSAUserPolicyDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get s a user policy default response
func (o *GetSAUserPolicyDefault) WithStatusCode(code int) *GetSAUserPolicyDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get s a user policy default response
func (o *GetSAUserPolicyDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get s a user policy default response
func (o *GetSAUserPolicyDefault) WithPayload(payload *models.APIError) *GetSAUserPolicyDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get s a user policy default response
func (o *GetSAUserPolicyDefault) SetPayload(payload *models.APIError) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSAUserPolicyDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
