// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package public

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// DownloadSharedObjectHandlerFunc turns a function with the right signature into a download shared object handler
type DownloadSharedObjectHandlerFunc func(DownloadSharedObjectParams) middleware.Responder

// Handle executing the request and returning a response
func (fn DownloadSharedObjectHandlerFunc) Handle(params DownloadSharedObjectParams) middleware.Responder {
	return fn(params)
}

// DownloadSharedObjectHandler interface for that can handle valid download shared object params
type DownloadSharedObjectHandler interface {
	Handle(DownloadSharedObjectParams) middleware.Responder
}

// NewDownloadSharedObject creates a new http.Handler for the download shared object operation
func NewDownloadSharedObject(ctx *middleware.Context, handler DownloadSharedObjectHandler) *DownloadSharedObject {
	return &DownloadSharedObject{Context: ctx, Handler: handler}
}

/*
	DownloadSharedObject swagger:route GET /download-shared-object/{url} Public downloadSharedObject

Downloads an object from a presigned url
*/
type DownloadSharedObject struct {
	Context *middleware.Context
	Handler DownloadSharedObjectHandler
}

func (o *DownloadSharedObject) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewDownloadSharedObjectParams()
	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
