// Code generated by go-swagger; DO NOT EDIT.

// This file is part of MinIO Console Server
// Copyright (c) 2023 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/minio/console/models"
)

// GetUserInfoOKCode is the HTTP code returned for type GetUserInfoOK
const GetUserInfoOKCode int = 200

/*
GetUserInfoOK A successful response.

swagger:response getUserInfoOK
*/
type GetUserInfoOK struct {

	/*
	  In: Body
	*/
	Payload *models.User `json:"body,omitempty"`
}

// NewGetUserInfoOK creates GetUserInfoOK with default headers values
func NewGetUserInfoOK() *GetUserInfoOK {

	return &GetUserInfoOK{}
}

// WithPayload adds the payload to the get user info o k response
func (o *GetUserInfoOK) WithPayload(payload *models.User) *GetUserInfoOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get user info o k response
func (o *GetUserInfoOK) SetPayload(payload *models.User) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetUserInfoOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetUserInfoDefault Generic error response.

swagger:response getUserInfoDefault
*/
type GetUserInfoDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.APIError `json:"body,omitempty"`
}

// NewGetUserInfoDefault creates GetUserInfoDefault with default headers values
func NewGetUserInfoDefault(code int) *GetUserInfoDefault {
	if code <= 0 {
		code = 500
	}

	return &GetUserInfoDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get user info default response
func (o *GetUserInfoDefault) WithStatusCode(code int) *GetUserInfoDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get user info default response
func (o *GetUserInfoDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get user info default response
func (o *GetUserInfoDefault) WithPayload(payload *models.APIError) *GetUserInfoDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get user info default response
func (o *GetUserInfoDefault) SetPayload(payload *models.APIError) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetUserInfoDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
