// This file is part of MinIO Console Server
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

import { SelectorType } from "mds";

const azureRegions: SelectorType[] = [
  {
    label: "Asia",
    value: "asia",
  },
  {
    label: "Asia Pacific",
    value: "asiapacific",
  },
  {
    label: "Australia",
    value: "australia",
  },
  {
    label: "Australia Central",
    value: "australiacentral",
  },
  {
    label: "Australia Central 2",
    value: "australiacentral2",
  },
  {
    label: "Australia East",
    value: "australiaeast",
  },
  {
    label: "Australia Southeast",
    value: "australiasoutheast",
  },
  {
    label: "Brazil",
    value: "brazil",
  },
  {
    label: "Brazil South",
    value: "brazilsouth",
  },
  {
    label: "Brazil Southeast",
    value: "brazilsoutheast",
  },
  {
    label: "Canada",
    value: "canada",
  },
  {
    label: "Canada Central",
    value: "canadacentral",
  },
  {
    label: "Canada East",
    value: "canadaeast",
  },
  {
    label: "Central India",
    value: "centralindia",
  },
  {
    label: "Central US",
    value: "centralus",
  },
  {
    label: "Central US (Stage)",
    value: "centralusstage",
  },
  {
    label: "Central US EUAP",
    value: "centraluseuap",
  },
  {
    label: "East Asia",
    value: "eastasia",
  },
  {
    label: "East Asia (Stage)",
    value: "eastasiastage",
  },
  {
    label: "East US",
    value: "eastus",
  },
  {
    label: "East US (Stage)",
    value: "eastusstage",
  },
  {
    label: "East US 2",
    value: "eastus2",
  },
  {
    label: "East US 2 (Stage)",
    value: "eastus2stage",
  },
  {
    label: "East US 2 EUAP",
    value: "eastus2euap",
  },
  {
    label: "Europe",
    value: "europe",
  },
  {
    label: "France",
    value: "france",
  },
  {
    label: "France Central",
    value: "francecentral",
  },
  {
    label: "France South",
    value: "francesouth",
  },
  {
    label: "Germany",
    value: "germany",
  },
  {
    label: "Germany North",
    value: "germanynorth",
  },
  {
    label: "Germany West Central",
    value: "germanywestcentral",
  },
  {
    label: "Global",
    value: "global",
  },
  {
    label: "India",
    value: "india",
  },
  {
    label: "Japan",
    value: "japan",
  },
  {
    label: "Japan East",
    value: "japaneast",
  },
  {
    label: "Japan West",
    value: "japanwest",
  },
  {
    label: "Jio India Central",
    value: "jioindiacentral",
  },
  {
    label: "Jio India West",
    value: "jioindiawest",
  },
  {
    label: "Korea",
    value: "korea",
  },
  {
    label: "Korea Central",
    value: "koreacentral",
  },
  {
    label: "Korea South",
    value: "koreasouth",
  },
  {
    label: "North Central US",
    value: "northcentralus",
  },
  {
    label: "North Central US (Stage)",
    value: "northcentralusstage",
  },
  {
    label: "North Europe",
    value: "northeurope",
  },
  {
    label: "Norway",
    value: "norway",
  },
  {
    label: "Norway East",
    value: "norwayeast",
  },
  {
    label: "Norway West",
    value: "norwaywest",
  },
  {
    label: "South Africa",
    value: "southafrica",
  },
  {
    label: "South Africa North",
    value: "southafricanorth",
  },
  {
    label: "South Africa West",
    value: "southafricawest",
  },
  {
    label: "South Central US",
    value: "southcentralus",
  },
  {
    label: "South Central US (Stage)",
    value: "southcentralusstage",
  },
  {
    label: "South India",
    value: "southindia",
  },
  {
    label: "Southeast Asia",
    value: "southeastasia",
  },
  {
    label: "Southeast Asia (Stage)",
    value: "southeastasiastage",
  },
  {
    label: "Sweden Central",
    value: "swedencentral",
  },
  {
    label: "Switzerland",
    value: "switzerland",
  },
  {
    label: "Switzerland North",
    value: "switzerlandnorth",
  },
  {
    label: "Switzerland West",
    value: "switzerlandwest",
  },
  {
    label: "UAE Central",
    value: "uaecentral",
  },
  {
    label: "UAE North",
    value: "uaenorth",
  },
  {
    label: "UK South",
    value: "uksouth",
  },
  {
    label: "UK West",
    value: "ukwest",
  },
  {
    label: "United Arab Emirates",
    value: "uae",
  },
  {
    label: "United Kingdom",
    value: "uk",
  },
  {
    label: "United States",
    value: "unitedstates",
  },
  {
    label: "United States EUAP",
    value: "unitedstateseuap",
  },
  {
    label: "West Central US",
    value: "westcentralus",
  },
  {
    label: "West Europe",
    value: "westeurope",
  },
  {
    label: "West India",
    value: "westindia",
  },
  {
    label: "West US",
    value: "westus",
  },
  {
    label: "West US (Stage)",
    value: "westusstage",
  },
  {
    label: "West US 2",
    value: "westus2",
  },
  {
    label: "West US 2 (Stage)",
    value: "westus2stage",
  },
  {
    label: "West US 3",
    value: "westus3",
  },
];
export default azureRegions;
